<?
#!/usr/bin/php
#---------------------------------------------------------------------------
# chord2html.php - A PHP script to convert CHORD input files to HTML
# Copyright (C) 2002 Andreas Motl <andreas.motl@ilo.de>
# 
# idea to port it to php and integrate with phpWiki:
# Copyright (C) 2002 Christoph Drieschner <christoph.drieschner@texorama.de>
#
# original perl version (chord2html.pl):
# Copyright (C) 1998,2002 Claudio Matsuoka <claudio@helllabs.org>
# with contributions from:
# Per Egil Kummervold <peregil@abex.no> and Erwin Burgstaller <i@wuell.net>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#---------------------------------------------------------------------------

// pre-set some of the formerly expected options ...
$opt_d = "img";
// ... and introduce some new ones
$opt_i = $input;
$opt_i = "itgwo.chopro";
$opt_v = 1;
$opt_t = 1;
$opt_s = "chord2html.css";
$opt_T = "png";

//use GD;
//use Getopt::Std;

//getopts ('d:hlno:qs:T:tVv');

// Defaults
// gnu date formats its date this way (by default): "Fri Oct 25 08:50:55 CEST 2002"
$date = date("D M d H:m:s T Y");
$version = "0.1";
$bg_color = "white";
$format = "png";
$color = "color=\"blue\"";
$style = $opt_s;
//$me = $0;

//$opt_q && ($opt_v = 0);

//if ($opt_V) {
    print "chord2html.php $version<br>\n";
    //exit;
//}

/*
if ($opt_h) {
    print STDERR <<EOF;
chord2html $version
Copyright (C) 1998,2002 Claudio Matsuoka <claudio\@helllabs.org>,
(C) 2002 Per Egil Kummervold <peregil\@abex.no>, (C) 2002 Erwin
Burgstaller <ber\@aon.at>

Usage: $me [options] input_file 
Options:
    -d dirname  Create images in the given directory (default is current)
    -h          Print a summary of the command line options
    -l          Print lyrics only
    -n          Don\'t overwrite chord images that already exist
    -o name     Write output to file (default is stdout)
    -q          Quiet mode (turn off warnings)
    -s filename Style sheet name (default is $style)
    -T format   Image format for generated chord grids (default is $format)
    -t          Add timestamp at the end of the generated page
    -V          Print version number
    -v          Verbose mode

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
for more details.
EOF
    exit 0;
}
*/

//$opt_o && (open (STDOUT, ">$opt_o") || die "$me: Can't create $opt_o\n");

if ($opt_d) {
/*
    if (opendir TESTDIR, $opt_d) {
	closedir TESTDIR;
    } else {
	mkdir ($opt_d, 0755) || die "$me: Can't create directory $opt_d\n";
    }
*/
    if (!preg_match('/\/$/', $opt_d)) { $opt_d .= "/"; }
}

function m($pattern, &$matches) {
  global $line;
  if (preg_match($pattern, $line, $matches)) {
    return 1;
  }
}

function mg($pattern, &$matches) {
  global $line;
  if (preg_match_all($pattern, $line, $matches)) {
    return 1;
  }
}

function r($pattern, $replacement) {
  global $line;
  if ($line = preg_replace($pattern, $replacement, $line)) {
    return 1;
  }
}

function logp($logstring) {
  global $opt_v, $log;
  if (!$opt_v) return;
  $log .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;=>" . $logstring . "\n";
  //print $logstring . "<br>";
}

function done() {
    $space = 0;
    $opt_l && print "<br>";
}



# =======================================
#  main
# =======================================

learn_chords();

$log = "";
$line = "";
$space = 1;		# Initialize as 1 to remove garbage before {t: }
$line_nr = 0;
$header = array();

// Parse input file
print "parsing input file $opt_i ...<br><hr>";
$file = file($opt_i);
foreach ($file as $line) {
    $line_nr++;

    r("/\n/", "");

    $opt_t && logp("&nbsp;&nbsp;&nbsp;--->" . $line);

    r("/^\s*#.*/", "");	// Clean up comments

    // TODO:
    // if (/{eot}/) { $tab = 0; %opt_l && next; print "\n</pre>\n"; next; }
    // $opt_l && $tab && next;
    // $tab && goto done;

    if (m("/{t:(.*)}/", $r) || m("/{title:(.*)}/", $r)) {
	logp("Title: $r[1]");
	$header['title'] = $r[1];
	continue;
    }

    if (m("/{st:(.*)}/", $r) || m("/{subtitle:(.*)}/", $r)) {
	logp("Subtitle: $r[1]");
	$header['subtitle'] = $r[1];
	continue;
    }

    if (is_array($header) && count($header) != -1) {
	do_header($header);
	unset($header);
    }

    // TODO:
    // Print lyrics only if -l is used
    /*
    if ($opt_l) { 
	m!{c[ib]?:(.*)}! && next;
	m!{comment\w*:(.*)}! && next;
    } else {
	s!{c[ib]?:(.*)}!<h3>$1</h3>! && goto done;
	s!{comment\w*:(.*)}!<p class="comment">$1</p>! && goto done;
    }
    */

    // Handle chord definition in old & new formats

    if (m("/{define:\s*([^\s]+) (\w) (\w) (\w) (\w) (\w) (\w) (\w)}/", $r)) {
	logp("Chord $r[8]$r[7]$r[6]$r[5]$r[4]$r[3]:$r[2]: $r[1] (old format)");
	$chord[$r[1]] = array( "$r[8]$r[7]$r[6]$r[5]$r[4]$r[3]", $r[2] );
	continue;
    }

    if (m("/{define\s*([^\s]+) base-fret (.) frets (.) (.) (.) (.) (.) (.)}/", $r)) {
	logp("Chord $r[8]$r[7]$r[6]$r[5]$r[4]$r[3]:$r[2]: $r[1] (new format)");
	$chord[$r[1]] = array( "$r[8]$r[7]$r[6]$r[5]$r[4]$r[3]", $r[2] );
	continue;
    }

    // TODO:
    // if (/{sot}/) { $tab = 1; $opt_l && next; print "\n<pre>\n"; next; }

    if (m("/{soc}/", $r)) { 
	r("/{soc}/", '/\n<div class="chorus">\n/'); 
	logp("{soc} -> div"); 
	done();
	continue; 
    }
    if (m("/{eoc}/", $r)) {
	r("/{eoc}/", "/\n</div>\n/");
	logp("{eoc} -> /div");
	done();
	continue;
    }

    if (m("/^\s*{(.*)}\s*$/", $r)) {
	logp("Warning: $line: unknown directive \"$r[1]\"");
	continue;
    }
 
    if (!$space && m("/^\s*$/", $r)) {
	r("/^\s*$/", "/\n<p>\n/");
	$space = 1;
	done();
        continue;
    }

    if (m("/^\s*$/", $r)) continue;
    $space = 0;

    // TODO:
    // Lyrics only mode
    if ($opt_l) {
	//s!\[[^\]]+\]!!g;
	//goto done;
    }

    // Extract chords
    //@c = /\[([^\]]+)\]/g;
    $pattern_chord = "/\[([^\]]+)\]/";

    print "<table cellspacing=0 cellpadding=0 border=0><tr>\n";
    $td = ""; if (!m("/^\s*\[/", $r)) { print $td = "<td>\n"; }

    if (mg($pattern_chord, $r)) {
      $entries = $r[0];
      foreach ($entries as $entry) {
          $entry = str_replace("[", "", $entry);
          $entry = str_replace("]", "", $entry);
	  $h[$entry] = 1;
	  print "<td class=\"chord\">$entry</td>\n";
      }
    }

    r("/\[[^\]]+\]\s\s+/", "<td> &nbsp; &nbsp; &nbsp; &nbsp; ");
    r("/\[[^\]]+\]\s+/", "<td> &nbsp; &nbsp; ");
    r("/\[[^\]]+\]/", "<td>");
    r("/ <td>/", "&nbsp;<td>");

    print "<tr>\n$td$line</tr></table>\n\n";


}

print "<hr>";
print "<pre style=\"font-size:10px;\">log-output:\n\n$log</pre><hr>";

//unless ($opt_l) {
    // Display chord grids
    print "<div class=\"grids\">\n";
    foreach ($h as $key => $value) {
        //print "key: $key<br>";
        if (!$chord[$key]) {
	    logp("Warning: unknown chord '$i'");
	    continue;
        }
        $tmp = "chord_" . $chord[$key][0] . "_" . $chord[$key][1] . "." . $format;
        print "<img alt=\"$key\" src=\"$opt_d$tmp\"> \n";
        build_chord($key, $tmp);
    }
    print "</div>\n";
//


//if ($opt_t) {
	?>
<br>
<div class="timestamp">
Generated with chord2html.php <?= $version ?>, <?= $date ?>.
</div>
<?
//}

?>
</body>
</html>
<?

#---------------------------------------------------------------------------
# Create html header
#---------------------------------------------------------------------------

function do_header($t) {
  global $version, $bg_color, $style;
  if ($header_done) return;

    ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title><?= $t[title] ?></title>
  <meta name="generator" content="chord2html <?= $version ?>">
  <meta name="description" content="<?= $t[subtitle] ?>">
  <meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type">
  <link rel="StyleSheet" href="<?= $style ?>" type="text/css">
</head>
<body bgcolor="<?= $bg_color ?>">
    <?

    $opt_l || print "<h1>$t[title]</h1>\n<h2>$t[subtitle]</h2>\n";

    $header_done = 1;
}

#---------------------------------------------------------------------------
# Create PNG image of chord using GD
#---------------------------------------------------------------------------

function build_chord($c, $image) {
    global $chord, $opt_d, $format;

    $s = $chord[$c][0]; 
    $f = $chord[$c][1]; 

    $imgfile = "$opt_d$image";

    // TODO: introduce an argument "rebuild"
    if (0 && file_exists($imgfile)) {
	logp("chord image $s:$f already exists -- skipping");
	return;
    }

    $im = ImageCreate(64, 64);
    $white = ImageColorAllocate ($im, 0xff, 0xff, 0xff);
    $black = ImageColorAllocate ($im, 0, 0, 0);
    //$h = gdLargeFont->height + 7;
    $h = 12 + 7;
    $i;

    ImageColorTransparent($im, $white);

    ImageInterlace($im, 0);
    ImageString($im, gdSmallFont, 12, 0, $c, $black);
    ($f != 1) && ImageString($im, gdSmallFont, 0, $h, $f, $black);

    for ($i = 0; $i < 6; $i++) {
	$c = substr($s, $i, 1);
	if (preg_match("/[NnXx-]/", $c)) {
	    ImageLine($im, 10 + $i * 8, $h - 7, 14 + $i * 8, $h - 3, $black);
	    ImageLine($im, 14 + $i * 8, $h - 7, 10 + $i * 8, $h - 3, $black);
	} elseif (preg_match("/[1234]/", $c)) {
	    ImageArc($im, 12 + $i * 8, $h + $c * 10 - 5, 5, 6, 0, 360, $black);
	    ImageFill($im, 12 + $i * 8, $h + $c * 10 - 5, $black);
	} elseif (preg_match("/0/", $c)) {
	    ImageArc($im, 12 + $i * 8, $h - 5, 6, 6, 0, 360, $black);
	}
    }

    for ($i = 12; $i < 60; $i += 8) {
	ImageLine($im, $i, $h, $i, 64, $black);
    }

    for ($i = $h; $i <= 64; $i += 10) {
	ImageLine($im, 12, $i, 52, $i, $black);
    }

    logp("Creating chord image $s:$f > $imgfile");

    #$fp = fopen($imgfile);
    #binmode FILE;
    if ($format == "png") {
        logp("Writing png to $imgfile");
	ImagePng($im, $imgfile);
    } elseif ($format == "gif") {
        logp("Writing gif to $imgfile");
	ImageGif($im, $imgfile);
    } else {
	logp("Unknown image format: $format");
    }
    #fclose($fp);

}


#---------------------------------------------------------------------------
# Chord definitions from CHORD 3.5
# CHORD is Copyright (C) 1991-1993 by Martin Leclerc & Mario Dorion
#---------------------------------------------------------------------------

function learn_chords() {
    global $chord;
    $chord = array(
	"Ab"		=> array( "133211", 4 ),
	"Ab+"		=> array( "NN2110", 1 ),
	"Ab4"		=> array( "NN1124", 1 ),
	"Ab7"		=> array( "NN1112", 1 ),
	"Ab11"		=> array( "131311", 4 ),
	"Absus"		=> array( "NN1124", 1 ),
	"Absus4"	=> array( "NN1124", 1 ),
	"Abdim"		=> array( "NN0101", 1 ),
	"Abmaj"		=> array( "133211", 4 ),
	"Abmaj7"	=> array( "NN1113", 1 ),
	"Abmin"		=> array( "133111", 4 ),
	"Abm"		=> array( "133111", 4 ),
	"Abm7"		=> array( "NN1111", 4 ),
	"A"		=> array( "N02220", 1 ),
	"A+"		=> array( "N03221", 1 ),
	"A4"		=> array( "002200", 1 ),
	"A6"		=> array( "NN2222", 1 ),
	"A7"		=> array( "N02020", 1 ),
	"A7+"		=> array( "NN3221", 1 ),
	"A7(9+)"	=> array( "N22223", 1 ),
	"A9"		=> array( "N02100", 1 ),
	"A11"		=> array( "N42433", 1 ),
	"A13"		=> array( "N01231", 5 ),
	"A7sus4"	=> array( "002030", 1 ),
	"A9sus"		=> array( "N02100", 1 ),
	"Asus"		=> array( "NN2230", 1 ),
	"Asus2"		=> array( "002200", 1 ),
	"Asus4"		=> array( "NN2230", 1 ),
	"Adim"		=> array( "NN1212", 1 ),
	"Amaj"		=> array( "N02220", 1 ),
	"Amaj7"		=> array( "N02120", 1 ),
	"Adim"		=> array( "NN1212", 1 ),
	"Amin"		=> array( "N02210", 1 ),
	"A/D"		=> array( "NN0022", 1 ),
	"A/F#"		=> array( "202220", 1 ),
	"A/G#"		=> array( "402220", 1 ),
	"Am"		=> array( "N02210", 1 ),
	"Am#7"		=> array( "NN2110", 1 ),
	"Am(7#)"	=> array( "N02214", 1 ),
	"Am6"		=> array( "N02212", 1 ),
	"Am7"		=> array( "N02213", 1 ),
	"Am7sus4"	=> array( "000030", 1 ),
	"Am9"		=> array( "N01113", 5 ),
	"Am/G"		=> array( "302210", 1 ),
	"Amadd9"	=> array( "022210", 1 ),
	"Am(add9)"	=> array( "022210", 1 ),
	"A#"		=> array( "N13331", 1 ),
	"A#+"		=> array( "NN0332", 1 ),
	"A#4"		=> array( "NN3341", 1 ),
	"A#7"		=> array( "NN1112", 3 ),
	"A#sus"		=> array( "NN3341", 1 ),
	"A#sus4"	=> array( "NN3341", 1 ),
	"A#maj"		=> array( "N13331", 1 ),
	"A#maj7"	=> array( "N1323N", 1 ),
	"A#dim"		=> array( "NN2323", 1 ),
	"A#min"		=> array( "N13321", 1 ),
	"A#m"		=> array( "N13321", 1 ),
	"A#m7"		=> array( "N13121", 1 ),
	"Bb"		=> array( "N13331", 1 ),
	"Bb+"		=> array( "NN0332", 1 ),
	"Bb4"		=> array( "NN3341", 1 ),
	"Bb6"		=> array( "NN3333", 1 ),
	"Bb7"		=> array( "NN1112", 3 ),
	"Bb9"		=> array( "131213", 6 ),
	"Bb11"		=> array( "131341", 6 ),
	"Bbsus"		=> array( "NN3341", 1 ),
	"Bbsus4"	=> array( "NN3341", 1 ),
	"Bbmaj"		=> array( "N13331", 1 ),
	"Bbmaj7"	=> array( "N1323N", 1 ),
	"Bbdim"		=> array( "NN2323", 1 ),
	"Bbmin"		=> array( "N13321", 1 ),
	"Bbm"		=> array( "N13321", 1 ),
	"Bbm7"		=> array( "N13121", 1 ),
	"Bbm9"		=> array( "NNN113", 6 ),
	"B"		=> array( "N24442", 1 ),
	"B+"		=> array( "NN1004", 1 ),
	"B4"		=> array( "NN3341", 2 ),
	"B7"		=> array( "021202", 1 ),
	"B7+"		=> array( "N21203", 1 ),
	"B7+5"		=> array( "N21203", 1 ),
	"B7#9"		=> array( "N2123N", 1 ),
	"B7(#9)"	=> array( "N2123N", 1 ),
	"B9"		=> array( "131213", 7 ),
	"B11"		=> array( "133200", 7 ),
	"B11/13"	=> array( "N11113", 2 ),
	"B13"		=> array( "N21204", 1 ),
	"Bsus"		=> array( "NN3341", 2 ),
	"Bsus4"		=> array( "NN3341", 2 ),
	"Bmaj"		=> array( "N2434N", 1 ),
	"Bmaj7"		=> array( "N2434N", 1 ),
	"Bdim"		=> array( "NN0101", 1 ),
	"Bmin"		=> array( "N24432", 1 ),
	"B/F#"		=> array( "022200", 2 ),
	"BaddE"		=> array( "N24400", 1 ),
	"B(addE)"	=> array( "N24400", 1 ),
	"BaddE/F#"	=> array( "2N4400", 1 ),
	"Bm"		=> array( "N24432", 1 ),
	"Bm6"		=> array( "NN4434", 1 ),
	"Bm7"		=> array( "N13121", 2 ),
	"Bmmaj7"	=> array( "N1443N", 1 ),
	"Bm(maj7)"	=> array( "N1443N", 1 ),
	"Bmsus9"	=> array( "NN4422", 1 ),
	"Bm(sus9)"	=> array( "NN4422", 1 ),
	"Bm7b5"		=> array( "124231", 1 ),
	"C"		=> array( "N32010", 1 ),
	"C+"		=> array( "NN2110", 1 ),
	"C4"		=> array( "NN3013", 1 ),
	"C6"		=> array( "N02213", 1 ),
	"C7"		=> array( "032310", 1 ),
	"C9"		=> array( "131213", 8 ),
	"C9(11)"	=> array( "N3333N", 1 ),
	"C11"		=> array( "N13141", 3 ),
	"Csus"		=> array( "NN3013", 1 ),
	"Csus2"		=> array( "N3001N", 1 ),
	"Csus4"		=> array( "NN3013", 1 ),
	"Csus9"		=> array( "NN4124", 7 ),
	"Cmaj"		=> array( "032010", 1 ),
	"Cmaj7"		=> array( "N32000", 1 ),
	"Cmin"		=> array( "N13321", 3 ),
	"Cdim"		=> array( "NN1212", 1 ),
	"C/B"		=> array( "N22010", 1 ),
	"Cadd2/B"	=> array( "N20010", 1 ),
	"CaddD"		=> array( "N32030", 1 ),
	"C(addD)"	=> array( "N32030", 1 ),
	"Cadd9"		=> array( "N32030", 1 ),
	"C(add9)"	=> array( "N32030", 1 ),
	"Cm"		=> array( "N13321", 3 ),
	"Cm7"		=> array( "N13121", 3 ),
	"Cm11"		=> array( "N1314N", 3 ),
	"C#"		=> array( "NN3121", 1 ),
	"C#+"		=> array( "NN3221", 1 ),
	"C#4"		=> array( "NN3341", 4 ),
	"C#7"		=> array( "NN3424", 1 ),
	"C#7(b5)"	=> array( "N21212", 1 ),
	"C#sus"		=> array( "NN3341", 4 ),
	"C#sus4"	=> array( "NN3341", 4 ),
	"C#maj"		=> array( "N43111", 1 ),
	"C#maj7"	=> array( "N43111", 1 ),
	"C#dim"		=> array( "NN2323", 1 ),
	"C#min"		=> array( "NN2120", 1 ),
	"C#add9"	=> array( "N13311", 4 ),
	"C#(add9)"	=> array( "N13311", 4 ),
	"C#m"		=> array( "NN2120", 1 ),
	"C#m7"		=> array( "NN2424", 1 ),
	"Db"		=> array( "NN3121", 1 ),
	"Db+"		=> array( "NN3221", 1 ),
	"Db7"		=> array( "NN3424", 1 ),
	"Dbsus"		=> array( "NN3341", 4 ),
	"Dbsus4"	=> array( "NN3341", 4 ),
	"Dbmaj"		=> array( "NN3121", 1 ),
	"Dbmaj7"	=> array( "N43111", 1 ),
	"Dbdim"		=> array( "NN2323", 1 ),
	"Dbmin"		=> array( "NN2120", 1 ),
	"Dbm"		=> array( "NN2120", 1 ),
	"Dbm7"		=> array( "NN2424", 1 ),
	"D"		=> array( "NN0232", 1 ),
	"D+"		=> array( "NN0332", 1 ),
	"D4"		=> array( "NN0233", 1 ),
	"D6"		=> array( "N00202", 1 ),
	"D7"		=> array( "NN0212", 1 ),
	"D7#9"		=> array( "N21233", 4 ),
	"D7(#9)"	=> array( "N21233", 4 ),
	"D9"		=> array( "131213",10 ),
	"D11"		=> array( "300210", 1 ),
	"Dsus"		=> array( "NN0233", 1 ),
	"Dsus2"		=> array( "000230", 1 ),
	"Dsus4"		=> array( "NN0233", 1 ),
	"D7sus2"	=> array( "N00210", 1 ),
	"D7sus4"	=> array( "N00213", 1 ),
	"Dmaj"		=> array( "NN0232", 1 ),
	"Dmaj7"		=> array( "NN0222", 1 ),
	"Ddim"		=> array( "NN0101", 1 ),
	"Dmin"		=> array( "NN0231", 1 ),
	"D/A"		=> array( "N00232", 1 ),
	"D/B"		=> array( "N20232", 1 ),
	"D/C"		=> array( "N30232", 1 ),
	"D/C#"		=> array( "N40232", 1 ),
	"D/E"		=> array( "N1111N", 7 ),
	"D/G"		=> array( "3N0232", 1 ),
	"D5/E"		=> array( "0111NN", 7 ),
	"Dadd9"		=> array( "000232", 1 ),
	"D(add9)"	=> array( "000232", 1 ),
	"D9add6"	=> array( "133200",10 ),
	"D9(add6)"	=> array( "133200",10 ),
	"Dm"		=> array( "NN0231", 1 ),
	"Dm6(5b)"	=> array( "NN0101", 1 ),
	"Dm7"		=> array( "NN0211", 1 ),
	"Dm#5"		=> array( "NN0332", 1 ),
	"Dm(#5)"	=> array( "NN0332", 1 ),
	"Dm#7"		=> array( "NN0221", 1 ),
	"Dm(#7)"	=> array( "NN0221", 1 ),
	"Dm/A"		=> array( "N00231", 1 ),
	"Dm/B"		=> array( "N20231", 1 ),
	"Dm/C"		=> array( "N30231", 1 ),
	"Dm/C#"		=> array( "N40231", 1 ),
	"Dm9"		=> array( "NN3210", 1 ),
	"D#"		=> array( "NN3121", 3 ),
	"D#+"		=> array( "NN1004", 1 ),
	"D#4"		=> array( "NN1344", 1 ),
	"D#7"		=> array( "NN1323", 1 ),
	"D#sus"		=> array( "NN1344", 1 ),
	"D#sus4"	=> array( "NN1344", 1 ),
	"D#maj"		=> array( "NN3121", 3 ),
	"D#maj7"	=> array( "NN1333", 1 ),
	"D#dim"		=> array( "NN1212", 1 ),
	"D#min"		=> array( "NN4342", 1 ),
	"D#m"		=> array( "NN4342", 1 ),
	"D#m7"		=> array( "NN1322", 1 ),
	"Eb"		=> array( "NN3121", 3 ),
	"Eb+"		=> array( "NN1004", 1 ),
	"Eb4"		=> array( "NN1344", 1 ),
	"Eb7"		=> array( "NN1323", 1 ),
	"Ebsus"		=> array( "NN1344", 1 ),
	"Ebsus4"	=> array( "NN1344", 1 ),
	"Ebmaj"		=> array( "NN1333", 1 ),
	"Ebmaj7"	=> array( "NN1333", 1 ),
	"Ebdim"		=> array( "NN1212", 1 ),
	"Ebadd9"	=> array( "N11341", 1 ),
	"Eb(add9)"	=> array( "N11341", 1 ),
	"Ebmin"		=> array( "NN4342", 1 ),
	"Ebm"		=> array( "NN4342", 1 ),
	"Ebm7"		=> array( "NN1322", 1 ),
	"E"		=> array( "022100", 1 ),
	"E+"		=> array( "NN2110", 1 ),
	"E5"		=> array( "0133NN", 7 ),
	"E6"		=> array( "NN3333", 9 ),
	"E7"		=> array( "022130", 1 ),
	"E7#9"		=> array( "022133", 1 ),
	"E7(#9)"	=> array( "022133", 1 ),
	"E7(5b)"	=> array( "N10130", 1 ),
	"E7b9"		=> array( "020132", 1 ),
	"E7(b9)"	=> array( "020132", 1 ),
	"E7(11)"	=> array( "022230", 1 ),
	"E9"		=> array( "131213", 1 ),
	"E11"		=> array( "111122", 1 ),
	"Esus"		=> array( "022200", 1 ),
	"Esus4"		=> array( "022200", 0 ),
	"Emaj"		=> array( "022100", 1 ),
	"Emaj7"		=> array( "02110N", 1 ),
	"Edim"		=> array( "NN2323", 1 ),
	"Emin"		=> array( "022000", 1 ),
	"Em"		=> array( "022000", 1 ),
	"Em6"		=> array( "022020", 1 ),
	"Em7"		=> array( "022030", 1 ),
	"Em/B"		=> array( "N22000", 1 ),
	"Em/D"		=> array( "NN0000", 1 ),
	"Em7/D"		=> array( "NN0000", 1 ),
	"Emsus4"	=> array( "002000", 1 ),
	"Em(sus4)"	=> array( "002000", 1 ),
	"Emadd9"	=> array( "024000", 1 ),
	"Em(add9)"	=> array( "024000", 1 ),
	"F"		=> array( "133211", 1 ),
	"F+"		=> array( "NN3221", 1 ),
	"F+7+11"	=> array( "133200", 1 ),
	"F4"		=> array( "NN3311", 1 ),
	"F6"		=> array( "N3323N", 1 ),
	"F7"		=> array( "131211", 1 ),
	"F9"		=> array( "242324", 1 ),
	"F11"		=> array( "131311", 1 ),
	"Fsus"		=> array( "NN3311", 1 ),
	"Fsus4"		=> array( "NN3311", 1 ),
	"Fmaj"		=> array( "133211", 1 ),
	"Fmaj7"		=> array( "N33210", 1 ),
	"Fdim"		=> array( "NN0101", 1 ),
	"Fmin"		=> array( "133111", 1 ),
	"F/A"		=> array( "N03211", 1 ),
	"F/C"		=> array( "NN3211", 1 ),
	"F/D"		=> array( "NN0211", 1 ),
	"F/G"		=> array( "333211", 1 ),
	"F7/A"		=> array( "N03011", 1 ),
	"Fmaj7/A"	=> array( "N03210", 1 ),
	"Fmaj7/C"	=> array( "N33210", 1 ),
	"Fmaj7(+5)"	=> array( "NN3220", 1 ),
	"Fadd9"		=> array( "303211", 1 ),
	"F(add9)"	=> array( "303211", 1 ),
	"FaddG"		=> array( "1N3213", 1 ),
	"FaddG"		=> array( "1N3213", 1 ),
	"Fm"		=> array( "133111", 1 ),
	"Fm6"		=> array( "NN0111", 1 ),
	"Fm7"		=> array( "131111", 1 ),
	"Fmmaj7"	=> array( "N33110", 1 ),
	"F#"		=> array( "244322", 1 ),
	"F#+"		=> array( "NN4332", 1 ),
	"F#7"		=> array( "NN4320", 1 ),
	"F#9"		=> array( "N12122", 1 ),
	"F#11"		=> array( "242422", 1 ),
	"F#sus"		=> array( "NN4422", 1 ),
	"F#sus4"	=> array( "NN4422", 1 ),
	"F#maj"		=> array( "244322", 0 ),
	"F#maj7"	=> array( "NN4321", 1 ),
	"F#dim"		=> array( "NN1212", 1 ),
	"F#min"		=> array( "244222", 1 ),
	"F#/E"		=> array( "044322", 1 ),
	"F#4"		=> array( "NN4422", 1 ),
	"F#m"		=> array( "244222", 1 ),
	"F#m6"		=> array( "NN1222", 1 ),
	"F#m7"		=> array( "NN2222", 1 ),
	"F#m7-5"	=> array( "102333", 2 ),
	"F#m/C#m"	=> array( "NN4222", 1 ),
	"Gb"		=> array( "244322", 1 ),
	"Gb+"		=> array( "NN4332", 1 ),
	"Gb7"		=> array( "NN4320", 1 ),
	"Gb9"		=> array( "N12122", 1 ),
	"Gbsus"		=> array( "NN4422", 1 ),
	"Gbsus4"	=> array( "NN4422", 1 ),
	"Gbmaj"		=> array( "244322", 1 ),
	"Gbmaj7"	=> array( "NN4321", 1 ),
	"Gbdim"		=> array( "NN1212", 1 ),
	"Gbmin"		=> array( "244222", 1 ),
	"Gbm"		=> array( "244222", 1 ),
	"Gbm7"		=> array( "NN2222", 1 ),
	"G"		=> array( "320003", 1 ),
	"G+"		=> array( "NN1004", 1 ),
	"G4"		=> array( "NN0013", 1 ),
	"G6"		=> array( "3N0000", 1 ),
	"G7"		=> array( "320001", 1 ),
	"G7+"		=> array( "NN4332", 1 ),
	"G7b9"		=> array( "NN0101", 1 ),
	"G7(b9)"	=> array( "NN0101", 1 ),
	"G7#9"		=> array( "13N244", 3 ),
	"G7(#9)"	=> array( "13N244", 3 ),
	"G9"		=> array( "3N0201", 1 ),
	"G9(11)"	=> array( "131313", 3 ),
	"G11"		=> array( "3N0211", 1 ),
	"Gsus"		=> array( "NN0013", 1 ),
	"Gsus4"		=> array( "NN0011", 1 ),
	"G6sus4"	=> array( "020010", 1 ),
	"G6(sus4)"	=> array( "020010", 1 ),
	"G7sus4"	=> array( "330011", 1 ),
	"G7(sus4)"	=> array( "330011", 1 ),
	"Gmaj"		=> array( "320003", 1 ),
	"Gmaj7"		=> array( "NN1234", 2 ),
	"Gmaj7sus4"	=> array( "NN0012", 1 ),
	"Gmaj9"		=> array( "114121", 2 ),
	"Gmin"		=> array( "133111", 3 ),
	"Gdim"		=> array( "NN2323", 1 ),
	"Gadd9"		=> array( "13N213", 3 ),
	"G(add9)"	=> array( "13N213", 3 ),
	"G/A"		=> array( "N00003", 1 ),
	"G/B"		=> array( "N20003", 1 ),
	"G/D"		=> array( "N22100", 4 ),
	"G/F#"		=> array( "220003", 1 ),
	"Gm"		=> array( "133111", 3 ),
	"Gm6"		=> array( "NN2333", 1 ),
	"Gm7"		=> array( "131111", 3 ),
	"Gm/Bb"		=> array( "3221NN", 4 ),
	"G#"		=> array( "133211", 4 ),
	"G#+"		=> array( "NN2110", 1 ),
	"G#4"		=> array( "133111", 4 ),
	"G#7"		=> array( "NN1112", 1 ),
	"G#sus"		=> array( "NN1124", 1 ),
	"G#sus4"	=> array( "NN1124", 1 ),
	"G#maj"		=> array( "133211", 4 ),
	"G#maj7"	=> array( "NN1113", 1 ),
	"G#dim"		=> array( "NN0101", 1 ),
	"G#min"		=> array( "133111", 4 ),
	"G#m"		=> array( "133111", 4 ),
	"G#m6"		=> array( "NN1101", 1 ),
	"G#m7"		=> array( "NN1111", 4 ),
	"G#m9maj7"	=> array( "NN1303", 1 ),
	"G#m9(maj7)"	=> array( "NN1303", 1 )
    );
}

